DEFINT A-Z

DECLARE SUB Poly3 (C%, X1%, Y1%, X2%, Y2%, X3%, Y3%) ' Thanks to LogicLord for
                                                     ' this routine.
DECLARE SUB TextToText (Buffer() AS ANY, Text$, Text2$)
DECLARE SUB EndText (Buffer() AS ANY, Text$)
DECLARE SUB StartText (Buffer() AS ANY, Text$)
DECLARE SUB Delay (Time AS DOUBLE)
DECLARE SUB xPrint (BSeg%, Text$, X%, Y%, Colour%)
DECLARE SUB BlurrScreen (NoZoom%)
DECLARE SUB AddPlane (Plane AS ANY, TempPlanes() AS ANY)
DECLARE SUB DrawPlanes (TempPlanes() AS ANY)
DECLARE SUB Draw3DBox (Plane AS ANY)
DECLARE SUB LoadModel (FileName AS STRING, Planes() AS ANY)
DECLARE SUB RotoZoomPoint (tPoint AS ANY, AngleX%, AngleY%, Zoom AS SINGLE, P AS ANY)
DECLARE SUB DrawModel (Planes() AS ANY, TempPlanes() AS ANY, AngleX%, AngleY%, Zoom AS SINGLE)

TYPE Point3D
 X    AS INTEGER
 Y    AS INTEGER
 Z    AS LONG
END TYPE

TYPE PlaneType
 P1   AS Point3D
 P2   AS Point3D
 P3   AS Point3D
 P4   AS Point3D
 Clr  AS INTEGER
END TYPE

ON ERROR GOTO Trapit

DIM SHARED yLut(200)       AS INTEGER
DIM SHARED Cosine(360)     AS SINGLE
DIM SHARED Sine(360)       AS SINGLE
DIM SHARED d4Lut(1024)     AS INTEGER
DIM SHARED cLut(-4 TO 255) AS INTEGER
REDIM Buffer(32001)        AS INTEGER
REDIM Sphere(0)            AS PlaneType
REDIM TempPlanes(0)        AS PlaneType
DIM Stars(500)             AS Point3D

pI180# = (ATN(1) + ATN(2) + ATN(3)) / 180
FOR I = 0 TO 360
 Cosine(I) = COS(I * pI180#)
 Sine(I) = SIN(I * pI180#)
NEXT I

FOR I = 1 TO 200
 yLut(I) = yLut(I - 1) + 320
NEXT I

FOR I = 1 TO 1024
 d4Lut(I) = I / 4
NEXT I

FOR I = 1 TO 255
 cLut(I) = I
NEXT

LoadModel "SPHERE.DAT", Sphere()

REDIM TempPlanes(UBOUND(Sphere, 1)) AS PlaneType

SCREEN 13

FOR C = 1 TO 255
 OUT &H3C8, C
 OUT &H3C9, C * .247
 OUT &H3C9, C * .247
 OUT &H3C9, C * .247
NEXT

RANDOMIZE TIMER

FOR I = 1 TO UBOUND(Stars, 1)
 Stars(I).Z = -300
 Stars(I).Y = (RND * 400) - 200
 Stars(I).X = (RND * 400) - 200
NEXT

Start# = TIMER
Zoom# = 1.5

DEF SEG = VARSEG(Buffer(0))

DO
 K$ = INKEY$

 SELECT CASE UCASE$(K$)
  CASE CHR$(27): Quit = -1
 END SELECT

 IF ((TIMER - Start#) > 35) AND (Zoom# <= 0) THEN
  Fade# = Fade# + .5
  FOR C = 1 TO 255
   CC = (C * .247) - Fade#: IF CC < 0 THEN CC = 0
   OUT &H3C8, C
   OUT &H3C9, CC
   OUT &H3C9, CC
   OUT &H3C9, CC
  NEXT
 END IF

 Angle = (Angle + 3) MOD 360

 NoZoom = (TIMER - Start#) < 15
 IF NoZoom = 0 AND Zoom# THEN ZD# = ZD# + .00002: Angle = (Angle + 3) MOD 360
 IF Zoom# >= 0 THEN
   Zoom# = Zoom# - ZD#
  ELSE
   Zoom# = 0
   IF Flash = 0 THEN
    O = 4
    FOR I = 1 TO 32000
     POKE O, 250: O = O + 1
     POKE O, 250: O = O + 1
    NEXT
    Flash = -1
   END IF
 END IF

 IF Zoom# THEN DrawModel Sphere(), TempPlanes(), (Angle), (Angle), (Zoom#)

 BlurrScreen NoZoom

 FOR I = 1 TO UBOUND(Stars, 1)
  Stars(I).Z = Stars(I).Z + 3 - ((NoZoom = 0) * 3)
  Z = Stars(I).Z - 50
  X = (((Stars(I).X * 256) / Z)) + 164
  Y = (((Stars(I).Y * 256) / Z)) + 100
  IF X > 318 OR Y > 198 OR X < 1 OR Y < 1 THEN
    Stars(I).Z = -300
    Stars(I).Y = (RND * 400) - 200
    Stars(I).X = (RND * 400) - 200
   ELSE
    ZC = (Stars(I).Z + 300) * .425
    POKE X + yLut(Y), ZC + 1
    POKE X + yLut(Y - 1), ZC
    POKE X + yLut(Y + 1), ZC
    POKE X - 1 + yLut(Y), ZC
    POKE X + 1 + yLut(Y), ZC
  END IF
 NEXT

 DrawPlanes TempPlanes()

 Buffer(0) = 2560: Buffer(1) = 200
 PUT (0, 0), Buffer(0), PSET
 FpsC& = FpsC& + 1
LOOP UNTIL Fade# >= 63

TotalTime# = (TIMER - Start#)

CLS
Delay 1

FOR C = 1 TO 255
 OUT &H3C8, C
 OUT &H3C9, C * .247
 OUT &H3C9, C * .247
 OUT &H3C9, C * .247
NEXT

StartText Buffer(), "The Sphere ... By Lithium."
TextToText Buffer(), "The Sphere ... By Lithium.", "PolyFiller by LogicLord."
TextToText Buffer(), "PolyFiller by LogicLord.", "Have a nice day."
EndText Buffer(), "Have a nice day."

SCREEN 0: WIDTH 80

PRINT "Fps:"; FpsC& / TotalTime#

END

Trapit:
RESUME NEXT

SUB AddPlane (Plane AS PlaneType, TempPlanes() AS PlaneType)
 FOR I = 1 TO UBOUND(TempPlanes, 1)
  IF TempPlanes(I).Clr = 0 THEN
   TempPlanes(I) = Plane
   EXIT SUB
  END IF
 NEXT
END SUB

SUB BlurrScreen (NoZoom)
 O = 4
 FOR I = 1 TO 32000
  O = O + 1: POKE (O), cLut((d4Lut((PEEK(O + 321) + PEEK(O + 319) + PEEK(O - 321) + PEEK(O - 319)))) + NoZoom)
  O = O + 1: POKE (O), cLut((d4Lut((PEEK(O + 321) + PEEK(O + 319) + PEEK(O - 321) + PEEK(O - 319)))) + NoZoom)
 NEXT
END SUB

SUB Delay (Time AS DOUBLE)
 Start# = TIMER
 DO: LOOP UNTIL (TIMER - Start#) > Time
END SUB

SUB Draw3DBox (Plane AS PlaneType)

 Z = Plane.P1.Z / 1024 - 50
 X0 = ((((Plane.P1.X / 1024) * 256) / Z)) + 160
 Y0 = ((((Plane.P1.Y / 1024) * 256) / Z)) + 100
 Z = Plane.P2.Z / 1024 - 50
 X1 = ((((Plane.P2.X / 1024) * 256) / Z)) + 160
 Y1 = ((((Plane.P2.Y / 1024) * 256) / Z)) + 100
 Z = Plane.P3.Z / 1024 - 50
 X2 = ((((Plane.P3.X / 1024) * 256) / Z)) + 160
 Y2 = ((((Plane.P3.Y / 1024) * 256) / Z)) + 100
 Z = Plane.P4.Z / 1024 - 50
 X3 = ((((Plane.P4.X / 1024) * 256) / Z)) + 160
 Y3 = ((((Plane.P4.Y / 1024) * 256) / Z)) + 100

 Clr = (Z / 1.5) * 2

 Poly3 (Clr), (X0), (Y0), (X1), (Y1), (X3), (Y3)
 Poly3 (Clr), (X1), (Y1), (X2), (Y2), (X3), (Y3)

END SUB

SUB DrawModel (Planes() AS PlaneType, TempPlanes() AS PlaneType, AngleX, AngleY, Zoom AS SINGLE)
 DIM Plane AS PlaneType

 FOR pI = 1 TO UBOUND(Planes, 1)
  Plane.Clr = -1
  RotoZoomPoint Planes(pI).P1, (AngleX), (AngleY), Zoom, Plane.P1
  RotoZoomPoint Planes(pI).P2, (AngleX), (AngleY), Zoom, Plane.P2
  RotoZoomPoint Planes(pI).P3, (AngleX), (AngleY), Zoom, Plane.P3
  RotoZoomPoint Planes(pI).P4, (AngleX), (AngleY), Zoom, Plane.P4
  AddPlane Plane, TempPlanes()
 NEXT
END SUB

SUB DrawPlanes (TempPlanes() AS PlaneType)
 FOR I = 1 TO UBOUND(TempPlanes, 1)
  FOR J = 1 TO UBOUND(TempPlanes, 1)
   IF TempPlanes(I).P1.Z < TempPlanes(J).P1.Z THEN SWAP TempPlanes(I), TempPlanes(J)
  NEXT
 NEXT
 FOR I = 1 TO UBOUND(TempPlanes, 1)
  IF TempPlanes(I).Clr THEN Draw3DBox TempPlanes(I): TempPlanes(I).Clr = 0
 NEXT
END SUB

SUB EndText (Buffer(), Text$)
 X = 160 - ((LEN(Text$) * 8) / 2)
 FOR I = 255 TO 1 STEP -3
  REDIM Buffer(32001)
  xPrint VARSEG(Buffer(0)), Text$, (X), (96), I
  Buffer(0) = 2560: Buffer(1) = 200
  PUT (0, 0), Buffer(0), PSET
  Delay .01
 NEXT
END SUB

SUB LoadModel (FileName AS STRING, Planes() AS PlaneType)
 F = FREEFILE
 OPEN FileName FOR INPUT AS #F
  INPUT #F, NumberPlanes
  REDIM Planes(NumberPlanes) AS PlaneType
  FOR I = 1 TO NumberPlanes
   INPUT #F, Planes(I).P1.X, Planes(I).P1.Y, Planes(I).P1.Z
   INPUT #F, Planes(I).P2.X, Planes(I).P2.Y, Planes(I).P2.Z
   INPUT #F, Planes(I).P3.X, Planes(I).P3.Y, Planes(I).P3.Z
   INPUT #F, Planes(I).P4.X, Planes(I).P4.Y, Planes(I).P4.Z
  NEXT
 CLOSE #F
END SUB

DEFSNG A-Z
SUB Poly3 (C%, X1%, Y1%, X2%, Y2%, X3%, Y3%)
IF (Y1% > Y2%) THEN SWAP X1%, X2%: SWAP Y1%, Y2%
IF (Y2% > Y3%) THEN SWAP X2%, X3%: SWAP Y2%, Y3%
IF (Y1% > Y2%) THEN SWAP X1%, X2%: SWAP Y1%, Y2%
O% = yLut(Y1%)
IF Y3% = Y1% THEN
 IF X1% < X2% THEN
  IF X2% < X3% THEN
   IF X1% < 0 THEN X1% = 0
   IF X3% > 319 THEN X3% = 319
   FOR I% = X1% TO X3%
    POKE I% + O%, C%
   NEXT I%
  ELSE
   IF X1% < 0 THEN X1% = 0
   IF X2% > 319 THEN X2% = 319
   FOR I% = X1% TO X2%
    POKE I% + O%, C%
   NEXT I%
  END IF
 ELSEIF X2% < X3% THEN
  IF X1% < X3% THEN
   IF X2% < 0 THEN X2% = 0
   IF X3% > 319 THEN X3% = 319
   FOR I% = X2% TO X3%
    POKE I% + O%, C%
   NEXT I%
  ELSE
   IF X2% < 0 THEN X2% = 0
   IF X1% > 319 THEN X1% = 319
   FOR I% = X2% TO X1%
    POKE I% + O%, C%
   NEXT I%
  END IF
 END IF
ELSE
 xl% = X1%
 xr% = X1%
 y21% = Y2% - Y1%
 y31% = Y3% - Y1%
 y32% = Y3% - Y2%
 tx% = (y21% * 1& * (X3% - X1%) + y31% \ 2) \ y31% + X1%
 IF Y1% = Y2% THEN
  IF X1% > X2% THEN
   IF X2% < 0 THEN
    IF X1% > 319 THEN
     FOR I% = 0 TO 319
      POKE I% + O%, C%
     NEXT I%
    ELSE
     FOR I% = 0 TO X1%
      POKE I% + O%, C%
     NEXT I%
    END IF
   ELSE
    IF X1% > 319 THEN
     FOR I% = X2% TO 319
      POKE I% + O%, C%
     NEXT I%
    ELSE
     FOR I% = X2% TO X1%
      POKE I% + O%, C%
     NEXT I%
    END IF
   END IF
  ELSE
   IF X1% < 0 THEN
    IF X2% > 319 THEN
     FOR I% = 0 TO 319
      POKE I% + O%, C%
     NEXT I%
    ELSE
     FOR I% = 0 TO X2%
      POKE I% + O%, C%
     NEXT I%
    END IF
   ELSE
    IF X2% > 319 THEN
     FOR I% = X1% TO 319
      POKE I% + O%, C%
     NEXT I%
    ELSE
     FOR I% = X1% TO X2%
      POKE I% + O%, C%
     NEXT I%
    END IF
   END IF
  END IF
  IF X1% < X2% THEN
   xr% = X2%
  ELSE
   xl% = X2%
  END IF
  sxl% = 0
  sxr% = 0
  IF tx% < X2% THEN
   dxl% = ((X3% - X1%) * 256& + y31% \ 2) \ (Y3% - Y1%)
   dsxl% = dxl% AND 255
   IF dxl% >= 0 THEN
    dxl% = dxl% \ 256
    sxl% = 0
   ELSE
    dxl% = dxl% \ 256 - 1
    sxl% = 256
   END IF
  ELSE
   dxr% = ((X3% - X1%) * 256& + y31% \ 2) \ (Y3% - Y1%)
   dsxr% = dxr% AND 255
   IF dxr% >= 0 THEN
    dxr% = dxr% \ 256
    sxr% = 0
   ELSE
    dxr% = dxr% \ 256 - 1
    sxr% = 256
   END IF
  END IF
 ELSE
  IF tx% > X2% THEN
   dxl% = ((X2% - X1%) * 256& + y21% \ 2) \ (Y2% - Y1%)
   dxr% = ((X3% - X1%) * 256& + y31% \ 2) \ (Y3% - Y1%)
  ELSE
   dxl% = ((X3% - X1%) * 256& + y31% \ 2) \ (Y3% - Y1%)
   dxr% = ((X2% - X1%) * 256& + y21% \ 2) \ (Y2% - Y1%)
  END IF
  dsxl% = dxl% AND 255
  IF dxl% >= 0 THEN
   dxl% = dxl% \ 256
   sxl% = 0
  ELSE
   dxl% = dxl% \ 256 - 1
   sxl% = 256
  END IF
  dsxr% = dxr% AND 255
  IF dxr% >= 0 THEN
   dxr% = dxr% \ 256
   sxr% = 0
  ELSE
   dxr% = dxr% \ 256 - 1
   sxr% = 256
  END IF
  FOR I% = Y1% TO Y2% - 1
   IF xl% > xr% THEN
    IF xr% < 0 THEN
     IF xl% > 319 THEN
      FOR J% = 0 TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = 0 TO xl%
       POKE J% + O%, C%
      NEXT J%
     END IF
    ELSE
     IF xl% > 319 THEN
      FOR J% = xr% TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = xr% TO xl%
       POKE J% + O%, C%
      NEXT J%
     END IF
    END IF
   ELSE
    IF xl% < 0 THEN
     IF xr% > 319 THEN
      FOR J% = 0 TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = 0 TO xr%
       POKE J% + O%, C%
      NEXT J%
     END IF
    ELSE
     IF xr% > 319 THEN
      FOR J% = xl% TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = xl% TO xr%
       POKE J% + O%, C%
      NEXT J%
     END IF
    END IF
   END IF
   O% = O% + 320
   xl% = xl% + dxl%
   xr% = xr% + dxr%
   sxl% = sxl% + dsxl%
   sxr% = sxr% + dsxr%
   IF sxl% > 255 THEN
    xl% = xl% + 1
    sxl% = sxl% - 256
   END IF
   IF sxr% > 255 THEN
    xr% = xr% + 1
    sxr% = sxr% - 256
   END IF
  NEXT I%
  IF X2% > tx% THEN
   FOR I% = tx% TO X2%
    POKE I% + O%, C%
   NEXT I%
  ELSE
   FOR I% = X2% TO tx%
    POKE I% + O%, C%
   NEXT I%
  END IF
 END IF
 O% = O% + 320
 IF Y2% <> Y3% THEN
  IF tx% > X2% THEN
   xl% = X2%
   dxl% = ((X3% - X2%) * 256& + y32% \ 2) \ (Y3% - Y2%)
   dsxl% = dxl% AND 255
   IF dxl% >= 0 THEN
    dxl% = dxl% \ 256
    sxl% = 0
   ELSE
    dxl% = dxl% \ 256 - 1
    sxl% = 256
   END IF
  ELSE
   xr% = X2%
   dxr% = ((X3% - X2%) * 256& + y32% \ 2) \ (Y3% - Y2%)
   dsxr% = dxr% AND 255
   IF dxr% >= 0 THEN
    dxr% = dxr% \ 256
    sxr% = 0
   ELSE
    dxr% = dxr% \ 256 - 1
    sxr% = 256
   END IF
  END IF
  FOR I% = Y2% + 1 TO Y3%
   xl% = xl% + dxl%
   xr% = xr% + dxr%
   sxl% = sxl% + dsxl%
   sxr% = sxr% + dsxr%
   IF sxl% > 255 THEN
    xl% = xl% + 1
    sxl% = sxl% - 256
   END IF
   IF sxr% > 255 THEN
    xr% = xr% + 1
    sxr% = sxr% - 256
   END IF
   IF xl% > xr% THEN
    IF xr% < 0 THEN
     IF xl% > 319 THEN
      FOR J% = 0 TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = 0 TO xl%
       POKE J% + O%, C%
      NEXT J%
     END IF
    ELSE
     IF xl% > 319 THEN
      FOR J% = xr% TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = xr% TO xl%
       POKE J% + O%, C%
      NEXT J%
     END IF
    END IF
   ELSE
    IF xl% < 0 THEN
     IF xr% > 319 THEN
      FOR J% = 0 TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = 0 TO xr%
       POKE J% + O%, C%
      NEXT J%
     END IF
    ELSE
     IF xr% > 319 THEN
      FOR J% = xl% TO 319
       POKE J% + O%, C%
      NEXT J%
     ELSE
      FOR J% = xl% TO xr%
       POKE J% + O%, C%
      NEXT J%
     END IF
    END IF
   END IF
   O% = O% + 320
  NEXT I%
 END IF
END IF
END SUB

DEFINT A-Z
SUB RotoZoomPoint (tPoint AS Point3D, AngleX, AngleY, Zoom AS SINGLE, P AS Point3D)
 OX = (tPoint.X * Zoom) * 1024: OY = (tPoint.Y * Zoom) * 1024: OZ = (tPoint.Z * Zoom) * 1024
 P.Y = (OY * Cosine(AngleX)) - (OZ * Sine(AngleX))
 P.Z = (OZ * Cosine(AngleX)) + (OY * Sine(AngleX)): OZ = P.Z
 P.Z = (OZ * Cosine(AngleY)) - (OX * Sine(AngleY))
 P.X = (OX * Cosine(AngleY)) + (OZ * Sine(AngleY))
END SUB

SUB StartText (Buffer(), Text$)
 X = 160 - ((LEN(Text$) * 8) / 2)
 FOR I = 1 TO 255 STEP 3
  REDIM Buffer(32001)
  xPrint VARSEG(Buffer(0)), Text$, (X), (96), (I)
  Delay .01
  Buffer(0) = 2560: Buffer(1) = 200
  PUT (0, 0), Buffer(0), PSET
 NEXT
 Delay 3
END SUB

SUB TextToText (Buffer(), Text$, Text2$)
 X = 160 - ((LEN(Text$) * 8) / 2)
 X2 = 160 - ((LEN(Text2$) * 8) / 2)
 FOR I = 255 TO 1 STEP -3
  REDIM Buffer(32001)
  IF I > 128 THEN
    xPrint VARSEG(Buffer(0)), Text2$, (X2), (96), (256 - I): xPrint VARSEG(Buffer(0)), Text$, (X), (96), (I)
   ELSE
    xPrint VARSEG(Buffer(0)), Text$, (X), (96), (I): xPrint VARSEG(Buffer(0)), Text2$, (X2), (96), 256 - I
  END IF
  Buffer(0) = 2560: Buffer(1) = 200
  PUT (0, 0), Buffer(0), PSET
  Delay .01
 NEXT
 Delay 3
END SUB

SUB xLine (X1, Y1, X2, Y2, Colour)

 DIM Offset AS LONG

 Offset = X1 + yLut(Y1)

 Xd = X2 - X1
 Yd = Y2 - Y1

 IF Xd >= 0 THEN
  XInc = 1
   ELSE
  XInc = -1
  Xd = -Xd
 END IF

 IF Yd >= 0 THEN
   YInc = 320
  ELSE
   YInc = -320
   Yd = -Yd
 END IF

  Xd2 = Xd + Xd
  Yd2 = Yd + Yd

 IF Xd > Yd THEN
   ErrorC = Yd2 - Xd

   FOR I = 0 TO Xd
    POKE Offset, Colour

    IF ErrorC >= 0 THEN
     ErrorC = ErrorC - Xd2
     Offset = Offset + YInc
    END IF

    ErrorC = ErrorC + Yd2
    Offset = Offset + XInc
   NEXT

  ELSE
 
   ErrorC = Xd2 - Yd

   FOR I = 0 TO Yd
    POKE Offset, Colour

    IF ErrorC >= 0 THEN
     ErrorC = ErrorC - Yd2
     Offset = Offset + XInc
    END IF

    ErrorC = ErrorC + Xd2
    Offset = Offset + YInc
   NEXT
 END IF

END SUB

SUB xPrint (BSeg, Text$, X, Y, Colour)
 X2 = X - 1
 Y2 = Y
 FOR I = 1 TO LEN(Text$)
  Offset = 8 * ASC(MID$(Text$, I, 1)) + &HE
  X2 = X2 + 8
  FOR J = 0 TO 7
   Y = yLut(Y2 + J)
   DEF SEG = &HFFA6: Char = PEEK(Offset + J): DEF SEG
   DEF SEG = BSeg
    IF Char AND 1 THEN POKE (X2 + Y), Colour
    IF Char AND 2 THEN POKE (X2 - 1 + Y), Colour
    IF Char AND 4 THEN POKE (X2 - 2 + Y), Colour
    IF Char AND 8 THEN POKE (X2 - 3 + Y), Colour
    IF Char AND 64 THEN POKE (X2 - 4 + Y), Colour
    IF Char AND 32 THEN POKE (X2 - 5 + Y), Colour
    IF Char AND 64 THEN POKE (X2 - 6 + Y), Colour
    IF Char AND 128 THEN POKE (X2 - 7 + Y), Colour
   DEF SEG
  NEXT
 NEXT
END SUB

